*** /dev/null
--- NetBSD/src/sys/arch/i386/conf/NETTAN
***************
*** 0 ****
--- 1,173 ----
+ #	$NetBSD: GENERIC,v 1.19 1995/07/24 03:33:12 mycroft Exp $
+ #
+ #	GENERIC -- everything that's currently supported
+ #
+ 
+ machine		i386		# architecture, used by config; REQUIRED
+ 
+ options		I386_CPU	# CPU classes; at least one is REQUIRED
+ options		I486_CPU
+ options		I586_CPU
+ options		MATH_EMULATE	# floating point emulation
+ 
+ #options	DUMMY_NOPS	# speed hack; recommanded
+ options		XSERVER,UCONSOLE
+ options		INSECURE	# insecure; allow /dev/mem writing for X
+ options		MACHINE_NONCONTIG
+ 
+ maxusers	32		# estimated number of users
+ options		TIMEZONE=0	# time zone to adjust RTC time by
+ options		DST=0		# daylight savings time used by RTC
+ 
+ options		SWAPPAGER	# paging; REQUIRED
+ options		VNODEPAGER	# mmap() of files
+ options		DEVPAGER	# mmap() of devices
+ 
+ options		DDB		# in-kernel debugger
+ #makeoptions	DEBUG="-g"	# compile full symbol table
+ options		DIAGNOSTIC	# internally consistency checks
+ options		KTRACE		# system call tracing, a la ktrace(1)
+ 
+ options		SYSVMSG		# System V-like message queues
+ options		SYSVSEM		# System V-like semaphores
+ options		SYSVSHM		# System V-like memory sharing
+ #options	SHMMAXPGS=1024	# 1024 pages is the default
+ 
+ options		COMPAT_NOMID	# compatibility with 386BSD, BSDI, NetBSD 0.8,
+ options		COMPAT_09	# NetBSD 0.9,
+ options		COMPAT_10	# NetBSD 1.0,
+ options		COMPAT_43	# and 4.3BSD
+ options		TCP_COMPAT_42	# TCP bug compatibility with 4.2BSD
+ 
+ options		COMPAT_SVR4	# binary compatibility with SVR4
+ options		COMPAT_IBCS2	# binary compatibility with SCO and ISC
+ options		COMPAT_LINUX	# binary compatibility with Linux
+ 
+ options		USER_LDT	# user-settable LDT; used by WINE
+ options		LKM		# loadable kernel modules
+ 
+ options		FFS		# UFS
+ options		QUOTA		# UFS quotas
+ options		LFS		# log-structured file system
+ options		MFS		# memory file system
+ 
+ options		NFSCLIENT	# Network File System client
+ options		NFSSERVER	# Network File System server
+ 
+ options		CD9660		# ISO 9660 + Rock Ridge file system
+ options		MSDOSFS		# MS-DOS file system
+ options		FDESC		# /dev/fd
+ options		FIFO		# FIFOs; RECOMMENDED
+ options		KERNFS		# /kern
+ options		NULLFS		# loopback file system
+ options		PORTAL		# ?
+ options		PROCFS		# /proc
+ options		UMAPFS		# NULLFS + uid and gid remapping
+ options		UNION		# union file system
+ 
+ #options	GATEWAY		# packet forwarding
+ options		INET		# IP + ICMP + TCP + UDP
+ options		NS		# XNS
+ options		ISO,TPIP	# OSI
+ options		EON		# OSI tunneling over IP
+ options		CCITT,LLC,HDLC	# X.25
+ 
+ config		netbsd	swap generic
+ options		GENERIC
+ 
+ isa0	at root
+ pci0	at root
+ 
+ npx0	at isa? port 0xf0 irq 13	# math coprocessor
+ 
+ pc0	at isa? port 0x60 irq 1		# generic PC console device
+ #vt0	at isa? port 0x60 irq 1
+ 
+ com0	at isa? port 0x3f8 irq 4	# standard PC serial ports
+ com1	at isa? port 0x2f8 irq 3
+ com2	at isa? port 0x3e8 irq 5
+ #com3	at isa? port 0x2e8 irq 9
+ #ast0	at isa? port 0x1a0 irq 5	# AST 4-port serial cards
+ #com*	at ast? slave ? flags 1
+ #boca0	at isa? port 0x100 irq 5	# BOCA 8-port serial cards
+ #com*	at boca? slave ?
+ #rtfps0	at isa? port 0x1230 irq 10	# RT 4-port serial cards
+ #com*	at rtfps? slave ?
+ 
+ #cy0	at isa? ...
+ 
+ lpt0	at isa? port 0x378 irq 7	# standard PC parallel ports
+ lpt1	at isa? port 0x278
+ lpt2	at isa? port 0x3bc
+ 
+ lms0	at isa? port 0x23c irq 5	# Logitech bus mouse
+ lms1	at isa? port 0x238 irq 5
+ mms0	at isa? port 0x23c irq 5	# Microsoft InPort mouse
+ mms1	at isa? port 0x238 irq 5
+ #pms0	at isa? port 0x60 irq 12	# PS/2 auxiliary port mouse
+ 
+ aha0	at isa? port 0x330 irq ? drq ?	# Adaptec 154[02] SCSI controllers
+ aha1	at isa? port 0x334 irq ? drq ?	# Adaptec 154[02] SCSI controllers
+ scsibus* at aha?
+ ahb0	at isa? port ? irq ?		# Adaptec 174[024] SCSI controllers
+ scsibus* at ahb?
+ aic0	at isa? port 0x340 irq 12	# Adaptec 152[02] SCSI controllers
+ scsibus* at aic?
+ bt0	at isa? port 0x330 irq ? drq ?	# BusLogic [57]4X SCSI controllers
+ bt1	at isa? port 0x334 irq ? drq ?	# BusLogic [57]4X SCSI controllers
+ bt2	at isa? port ? irq ?
+ scsibus* at bt?
+ ncr*	at pci? bus ? dev ?		# NCR 538XX SCSI controllers
+ scsibus* at ncr?
+ sea0	at isa? iomem 0xc8000 irq 5
+ scsibus* at sea?
+ uha0	at isa? port 0x330 irq ? drq ?	# UltraStor [13]4f SCSI controllers
+ uha1	at isa? port 0x334 irq ? drq ?	# UltraStor [13]4f SCSI controllers
+ uha2	at isa? port ? irq ?		# UltraStor 24f SCSI controllers
+ scsibus* at uha?
+ 
+ sd*	at scsibus? target ? lun ?	# SCSI disk drives
+ st*	at scsibus? target ? lun ?	# SCSI tape drives
+ cd*	at scsibus? target ? lun ?	# SCSI CD-ROM drives
+ ch*	at scsibus? target ? lun ?	# SCSI autochangers
+ 
+ fdc0	at isa? port 0x3f0 irq 6 drq 2	# standard PC floppy controllers
+ #fdc1	at isa? port 0x370 irq ? drq ?
+ fd*	at fdc? drive ?
+ 
+ mcd0	at isa? port 0x300 irq 10	# Mitsumi CD-ROM drives
+ 
+ wdc0	at isa? port 0x1f0 irq 14	# ST506, ESDI, and IDE controllers
+ #wdc1	at isa? port 0x170 irq ?
+ wd*	at wdc? drive ?
+ 
+ wt0	at isa? port 0x300 irq 5 drq 1	# Archive and Wangtek QIC tape drives
+ 
+ ed0	at isa? port 0x280 iomem 0xd0000 irq 9	# WD/SMC, 3C503, and NE[12]000
+ ed1	at isa? port 0x250 iomem 0xd8000 irq 9	#   ethernet cards
+ ed2	at isa? port 0x300 iomem 0xcc000 irq 10
+ #eg0	at isa? ...				# 3C505 ethernet cards
+ el0	at isa? port 0x300 irq 9		# 3C501 ethernet cards
+ ep0	at isa? port ? irq ?			# 3C509 ethernet cards
+ ie0	at isa? port 0x360 iomem 0xd0000 irq 7	# StarLAN & 3C507 ethernet cards
+ #le0	at isa? port 0x320 irq 10 drq 7		# IsoLan, NE2100, and DEPCA
+ de*	at pci? bus ? dev ?
+ 
+ pss0	at isa? port 0x220 irq 7 drq 6  # Personal Sound System
+ sp0	at pss0 port 0x530 irq 10 drq 0	# 	sound port driver
+ 
+ sb0	at isa? port 0x220 irq 7 drq 1	# SoundBlaster
+ wss0	at isa? port 0x530 irq 10 drq 0	# Windows Sound System
+ pas0	at isa? port 0x220 irq 7 drq 1	# ProAudio Spectrum
+ gus0	at isa? port 0x220 irq 7 drq 1 flags 6 # Gravis Ultra Sound (flags is record drq for full-duplex)
+ #spkr0	at isa? ...
+ 
+ pseudo-device	loop	1		# network loopback
+ pseudo-device	bpfilter 8		# packet filter
+ pseudo-device	sl	2		# CSLIP
+ pseudo-device	ppp	2		# PPP
+ pseudo-device	tun	2		# network tunneling over tty
+ 
+ pseudo-device	pty	64		# pseudo-terminals
+ pseudo-device	tb	1		# tablet line discipline
+ pseudo-device	vnd	4		# paging to files
*** old-NetBSD/src/sys/dev/cons.h
--- NetBSD/src/sys/dev/cons.h
***************
*** 80,85 ****
--- 80,86 ----
  int	cnselect __P((dev_t, int, struct proc *));
  int	cngetc __P((void));
  int	cnputc __P((int));
+ void	nullcnpollc __P((int));
  
  /* console-specific types */
  #define	dev_type_cnprobe(n)	void n __P((struct consdev *))
*** old-NetBSD/src/sys/dev/ic/dp8390reg.h
--- NetBSD/src/sys/dev/ic/dp8390reg.h
***************
*** 530,536 ****
   * was received.
   */
  struct ed_ring	{
! #if BYTE_ORDER == BIG_ENDIAN
  	u_char	next_packet;		/* pointer to next packet */
  	u_char	rsr;			/* receiver status */
  #else
--- 530,536 ----
   * was received.
   */
  struct ed_ring	{
! #if ED_BYTE_ORDER == BIG_ENDIAN
  	u_char	next_packet;		/* pointer to next packet */
  	u_char	rsr;			/* receiver status */
  #else
*** old-NetBSD/src/sys/dev/isa/com.c
--- NetBSD/src/sys/dev/isa/com.c
***************
*** 100,105 ****
--- 100,106 ----
  void compoll __P((void *));
  int comparam __P((struct tty *, struct termios *));
  void comstart __P((struct tty *));
+ int comhwiflow __P((struct tty *, int));
  
  struct cfdriver comcd = {
  	NULL, "com", comprobe, comattach, DV_TTY, sizeof(struct com_softc)
***************
*** 282,287 ****
--- 283,289 ----
  
  	tp->t_oproc = comstart;
  	tp->t_param = comparam;
+ 	tp->t_hwiflow = comhwiflow;
  	tp->t_dev = dev;
  	if ((tp->t_state & TS_ISOPEN) == 0) {
  		tp->t_state |= TS_WOPEN;
***************
*** 879,884 ****
--- 881,915 ----
  		if (inb(iobase + com_iir) & IIR_NOPEND)
  			return (1);
  	}
+ }
+ 
+ int
+ comhwiflow(tp, flag)
+         struct tty *tp;
+         int flag;
+ {
+ 	struct com_softc *sc = comcd.cd_devs[COMUNIT(tp->t_dev)];
+ 	int iobase = sc->sc_iobase;
+ 	int s;
+ 	static unsigned int startusec, startticks;
+ 	extern int ticks;
+ 	int elapsed;
+ 
+ 	s = spltty();
+         if (flag) {
+ 		sc->sc_mcr &= ~MCR_RTS;
+ 		startusec = clkread();
+ 		startticks = ticks;
+ 	} else {
+ 	        elapsed = clkread() - startusec + (ticks - startticks) * 10000;
+ 	        sc->sc_mcr |= MCR_RTS;
+ 	}
+ 	outb(iobase + com_mcr, sc->sc_mcr);
+ 	splx(s);
+ 	if (!flag)
+ 		printf ("%s: comhwiflow %d ms\n", sc->sc_dev.dv_xname,
+ 		    elapsed / 1000);
+         return 1;
  }
  
  /*
*** old-NetBSD/src/sys/dev/isa/if_ed.c
--- NetBSD/src/sys/dev/isa/if_ed.c
***************
*** 518,524 ****
  	(void) inb(0x84);
  
  	/* Now zero memory and verify that it is clear. */
! 	bzero(sc->mem_start, memsize);
  
  	for (i = 0; i < memsize; ++i)
  		if (sc->mem_start[i]) {
--- 518,524 ----
  	(void) inb(0x84);
  
  	/* Now zero memory and verify that it is clear. */
! 	isa_zero(sc->mem_start, memsize);
  
  	for (i = 0; i < memsize; ++i)
  		if (sc->mem_start[i]) {
***************
*** 784,790 ****
  	outb(sc->asic_addr + ED_3COM_VPTR0, 0x00);
  
  	/* Zero memory and verify that it is clear. */
! 	bzero(sc->mem_start, memsize);
  
  	for (i = 0; i < memsize; ++i)
  		if (sc->mem_start[i]) {
--- 784,790 ----
  	outb(sc->asic_addr + ED_3COM_VPTR0, 0x00);
  
  	/* Zero memory and verify that it is clear. */
! 	isa_zero(sc->mem_start, memsize);
  
  	for (i = 0; i < memsize; ++i)
  		if (sc->mem_start[i]) {
***************
*** 1401,1407 ****
  		}
  
  		for (m = m0; m != 0; m = m->m_next) {
! 			bcopy(mtod(m, caddr_t), buffer, m->m_len);
  			buffer += m->m_len;
  		}
  		len = m0->m_pkthdr.len;
--- 1401,1407 ----
  		}
  
  		for (m = m0; m != 0; m = m->m_next) {
! 			copy_to_isa(mtod(m, caddr_t), buffer, m->m_len);
  			buffer += m->m_len;
  		}
  		len = m0->m_pkthdr.len;
***************
*** 1488,1494 ****
  		else
  			ed_pio_readmem(sc, (long)packet_ptr,
  			    (caddr_t) &packet_hdr, sizeof(packet_hdr));
! 		len = packet_hdr.count;
  
  		/*
  		 * Try do deal with old, buggy chips that sometimes duplicate
--- 1488,1494 ----
  		else
  			ed_pio_readmem(sc, (long)packet_ptr,
  			    (caddr_t) &packet_hdr, sizeof(packet_hdr));
! 		len = itohs(packet_hdr.count);
  
  		/*
  		 * Try do deal with old, buggy chips that sometimes duplicate
***************
*** 1508,1518 ****
  			--nlen;
  		len = (len & ED_PAGE_MASK) | (nlen << ED_PAGE_SHIFT);
  #ifdef DIAGNOSTIC
! 		if (len != packet_hdr.count) {
  			printf("%s: length does not match next packet pointer\n",
  			    sc->sc_dev.dv_xname);
  			printf("%s: len %04x nlen %04x start %02x first %02x curr %02x next %02x stop %02x\n",
! 			    sc->sc_dev.dv_xname, packet_hdr.count, len,
  			    sc->rec_page_start, sc->next_packet, current,
  			    packet_hdr.next_packet, sc->rec_page_stop);
  		}
--- 1508,1518 ----
  			--nlen;
  		len = (len & ED_PAGE_MASK) | (nlen << ED_PAGE_SHIFT);
  #ifdef DIAGNOSTIC
! 		if (len != itohs(packet_hdr.count)) {
  			printf("%s: length does not match next packet pointer\n",
  			    sc->sc_dev.dv_xname);
  			printf("%s: len %04x nlen %04x start %02x first %02x curr %02x next %02x stop %02x\n",
! 			    sc->sc_dev.dv_xname, itohs(packet_hdr.count), len,
  			    sc->rec_page_start, sc->next_packet, current,
  			    packet_hdr.next_packet, sc->rec_page_stop);
  		}
***************
*** 2119,2125 ****
  
  		/* Copy amount up to end of NIC memory. */
  		if (sc->mem_shared)
! 			bcopy(src, dst, tmp_amount);
  		else
  			ed_pio_readmem(sc, (long)src, dst, tmp_amount);
  
--- 2119,2125 ----
  
  		/* Copy amount up to end of NIC memory. */
  		if (sc->mem_shared)
! 			copy_from_isa(src, dst, tmp_amount);
  		else
  			ed_pio_readmem(sc, (long)src, dst, tmp_amount);
  
***************
*** 2129,2135 ****
  	}
  
  	if (sc->mem_shared)
! 		bcopy(src, dst, amount);
  	else
  		ed_pio_readmem(sc, (long)src, dst, amount);
  
--- 2129,2135 ----
  	}
  
  	if (sc->mem_shared)
! 		copy_from_isa(src, dst, amount);
  	else
  		ed_pio_readmem(sc, (long)src, dst, amount);
  
*** old-NetBSD/src/sys/kern/exec_conf.c
--- NetBSD/src/sys/kern/exec_conf.c
***************
*** 37,42 ****
--- 37,46 ----
  #define EXEC_ECOFF
  #endif
  
+ #if defined(COMPAT_NCR32)
+ #define EXEC_COFF
+ #endif
+ 
  #if defined(COMPAT_SVR4) || defined(COMPAT_LINUX)
  #define EXEC_ELF
  #endif
***************
*** 56,61 ****
--- 60,69 ----
  #include <sys/exec_ecoff.h>
  #endif
  
+ #ifdef EXEC_COFF
+ #include <sys/exec_coff.h>
+ #endif
+ 
  #ifdef EXEC_ELF
  #include <sys/exec_elf.h>
  #endif
***************
*** 88,93 ****
--- 96,104 ----
  #endif
  #ifdef EXEC_ECOFF
  	{ ECOFF_HDR_SIZE, exec_ecoff_makecmds, },	/* ecoff binaries */
+ #endif
+ #ifdef EXEC_COFF
+ 	{ COFF_HDR_SIZE, exec_coff_makecmds, },	/* coff binaries */
  #endif
  #ifdef EXEC_ELF
  	{ ELF_HDR_SIZE, exec_elf_makecmds, },	/* elf binaries */
*** old-NetBSD/src/sys/kern/kern_lkm.c
--- NetBSD/src/sys/kern/kern_lkm.c
***************
*** 81,86 ****
--- 81,90 ----
  static struct lkm_table	lkmods[MAXLKMS];	/* table of loaded modules */
  static struct lkm_table	*curp;			/* global for in-progress ops */
  
+ #ifdef DEBUG
+ int lkm_debug = 0;
+ #endif
+ 
  /*ARGSUSED*/
  int
  lkmopen(dev, flag, devtype, p)
***************
*** 148,154 ****
  
  	if (!(lkm_v & LKM_ALLOC)) {
  #ifdef DEBUG
! 		printf("LKM: close before open!\n");
  #endif	/* DEBUG */
  		return (EBADF);
  	}
--- 152,159 ----
  
  	if (!(lkm_v & LKM_ALLOC)) {
  #ifdef DEBUG
! 	        if (lkm_debug)
! 		        printf("LKM: close before open!\n");
  #endif	/* DEBUG */
  		return (EBADF);
  	}
***************
*** 220,228 ****
  		resrvp->addr = curp->area; /* ret kernel addr */
  
  #ifdef DEBUG
! 		printf("LKM: LMRESERV (actual   = 0x%08x)\n", curp->area);
! 		printf("LKM: LMRESERV (adjusted = 0x%08x)\n",
! 			trunc_page(curp->area));
  #endif	/* DEBUG */
  		lkm_state = LKMS_RESERVED;
  		break;
--- 225,235 ----
  		resrvp->addr = curp->area; /* ret kernel addr */
  
  #ifdef DEBUG
! 		if (lkm_debug) {
! 		        printf("LKM: LMRESERV (actual   = 0x%08x)\n", curp->area);
! 		        printf("LKM: LMRESERV (adjusted = 0x%08x)\n",
! 			       trunc_page(curp->area));
! 		}
  #endif	/* DEBUG */
  		lkm_state = LKMS_RESERVED;
  		break;
***************
*** 248,260 ****
  		if ((curp->offset + i) < curp->size) {
  			lkm_state = LKMS_LOADING;
  #ifdef DEBUG
! 			printf("LKM: LMLOADBUF (loading @ %d of %d, i = %d)\n",
! 			curp->offset, curp->size, i);
  #endif	/* DEBUG */
  		} else {
  			lkm_state = LKMS_LOADED;
  #ifdef DEBUG
! 			printf("LKM: LMLOADBUF (loaded)\n");
  #endif	/* DEBUG */
  		}
  		curp->offset += i;
--- 255,269 ----
  		if ((curp->offset + i) < curp->size) {
  			lkm_state = LKMS_LOADING;
  #ifdef DEBUG
! 			if (lkm_debug)
! 			        printf("LKM: LMLOADBUF (loading @ %d of %d, i = %d)\n",
! 			               curp->offset, curp->size, i);
  #endif	/* DEBUG */
  		} else {
  			lkm_state = LKMS_LOADED;
  #ifdef DEBUG
! 			if (lkm_debug)
! 			        printf("LKM: LMLOADBUF (loaded)\n");
  #endif	/* DEBUG */
  		}
  		curp->offset += i;
***************
*** 266,272 ****
  
  		lkmunreserve();	/* coerce state to LKM_IDLE */
  #ifdef DEBUG
! 		printf("LKM: LMUNRESERV\n");
  #endif	/* DEBUG */
  		break;
  
--- 275,282 ----
  
  		lkmunreserve();	/* coerce state to LKM_IDLE */
  #ifdef DEBUG
! 	        if (lkm_debug)
! 		        printf("LKM: LMUNRESERV\n");
  #endif	/* DEBUG */
  		break;
  
***************
*** 285,291 ****
  		default:
  
  #ifdef DEBUG
! 			printf("lkm_state is %02x\n", lkm_state);
  #endif	/* DEBUG */
  			return ENXIO;
  		}
--- 295,302 ----
  		default:
  
  #ifdef DEBUG
! 		        if (lkm_debug)
! 			        printf("lkm_state is %02x\n", lkm_state);
  #endif	/* DEBUG */
  			return ENXIO;
  		}
***************
*** 306,312 ****
  
  		curp->used = 1;
  #ifdef DEBUG
! 		printf("LKM: LMREADY\n");
  #endif	/* DEBUG */
  		lkm_state = LKMS_IDLE;
  		break;
--- 317,324 ----
  
  		curp->used = 1;
  #ifdef DEBUG
! 	        if (lkm_debug)
! 		        printf("LKM: LMREADY\n");
  #endif	/* DEBUG */
  		lkm_state = LKMS_IDLE;
  		break;
*** old-NetBSD/src/sys/kern/tty.c
--- NetBSD/src/sys/kern/tty.c
***************
*** 1045,1058 ****
  	 */
  	if (total >= TTYHOG / 2 &&
  	    !ISSET(tp->t_state, TS_TBLOCK) &&
! 	    !ISSET(tp->t_lflag, ICANON) || tp->t_canq.c_cc > 0) {
  		if (ISSET(tp->t_iflag, IXOFF) &&
  		    tp->t_cc[VSTOP] != _POSIX_VDISABLE &&
  		    putc(tp->t_cc[VSTOP], &tp->t_outq) == 0) {
! 			SET(tp->t_state, TS_TBLOCK);
  			ttstart(tp);
  		}
! 		/* Try to block remote output via hardware flow control. */
  		if (ISSET(tp->t_cflag, CHWFLOW) && tp->t_hwiflow &&
  		    (*tp->t_hwiflow)(tp, 1) != 0)
  			SET(tp->t_state, TS_TBLOCK);
--- 1045,1058 ----
  	 */
  	if (total >= TTYHOG / 2 &&
  	    !ISSET(tp->t_state, TS_TBLOCK) &&
! 	    (!ISSET(tp->t_lflag, ICANON) || tp->t_canq.c_cc > 0)) {
  		if (ISSET(tp->t_iflag, IXOFF) &&
  		    tp->t_cc[VSTOP] != _POSIX_VDISABLE &&
  		    putc(tp->t_cc[VSTOP], &tp->t_outq) == 0) {
! 	        	SET(tp->t_state, TS_TBLOCK);
  			ttstart(tp);
  		}
! 		/* Try to block remote output via hardware flow control */
  		if (ISSET(tp->t_cflag, CHWFLOW) && tp->t_hwiflow &&
  		    (*tp->t_hwiflow)(tp, 1) != 0)
  			SET(tp->t_state, TS_TBLOCK);
***************
*** 1379,1388 ****
  			CLR(tp->t_state, TS_TBLOCK);
  			ttstart(tp);
  		}
! 		/* Try to unblock remote output via hardware flow control. */
  		if (ISSET(tp->t_cflag, CHWFLOW) && tp->t_hwiflow &&
  		    (*tp->t_hwiflow)(tp, 0) != 0)
! 			CLR(tp->t_state, TS_TBLOCK);
  	}
  	splx(s);
  	return (error);
--- 1379,1388 ----
  			CLR(tp->t_state, TS_TBLOCK);
  			ttstart(tp);
  		}
! 		/* Try to unblock remote output via hardware flow control */
  		if (ISSET(tp->t_cflag, CHWFLOW) && tp->t_hwiflow &&
  		    (*tp->t_hwiflow)(tp, 0) != 0)
! 			tp->t_state &= ~TS_TBLOCK;
  	}
  	splx(s);
  	return (error);
*** old-NetBSD/src/sys/lib/libkern/arch/m68k/Makefile.inc
--- NetBSD/src/sys/lib/libkern/arch/m68k/Makefile.inc
***************
*** 2,5 ****
  
  SRCS+=	__main.c imax.c imin.c lmax.c lmin.c max.c min.c ulmax.c ulmin.c \
  	bcmp.S bzero.S ffs.S strcat.c strcmp.S strcpy.S strlen.S strncmp.S \
! 	strncpy.S htonl.S htons.S ntohl.S ntohs.S scanc.S skpc.S locc.S
--- 2,6 ----
  
  SRCS+=	__main.c imax.c imin.c lmax.c lmin.c max.c min.c ulmax.c ulmin.c \
  	bcmp.S bzero.S ffs.S strcat.c strcmp.S strcpy.S strlen.S strncmp.S \
! 	strncpy.S htonl.S htons.S ntohl.S ntohs.S scanc.S skpc.S locc.S \
! 	memcpy.S
*** /dev/null
--- NetBSD/src/sys/lib/libkern/arch/m68k/bcopy.S
***************
*** 0 ****
--- 1,132 ----
+ /*-
+  * Copyright (c) 1990 The Regents of the University of California.
+  * All rights reserved.
+  *
+  * This code is derived from software contributed to Berkeley by
+  * the Systems Programming Group of the University of Utah Computer
+  * Science Department.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 3. All advertising materials mentioning features or use of this software
+  *    must display the following acknowledgement:
+  *	This product includes software developed by the University of
+  *	California, Berkeley and its contributors.
+  * 4. Neither the name of the University nor the names of its contributors
+  *    may be used to endorse or promote products derived from this software
+  *    without specific prior written permission.
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+  * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+  * SUCH DAMAGE.
+  */
+ 
+ #if defined(LIBC_SCCS) && !defined(lint)
+ 	.text
+ 	/*.asciz "from: @(#)bcopy.s	5.1 (Berkeley) 5/12/90"*/
+ 	.asciz "$Id$"
+ #endif /* LIBC_SCCS and not lint */
+ 
+ #include "DEFS.h"
+ 
+ /*
+  * This is probably not the best we can do, but it is still 2-10 times
+  * faster than the C version in the portable gen directory.
+  *
+  * Things that might help:
+  *	- unroll the longword copy loop (might not be good for a 68020)
+  *	- longword align when possible (only on the 68020)
+  *	- use nested DBcc instructions or use one and limit size to 64K
+  */
+ #ifdef MEMCOPY
+ ENTRY(memcpy)
+ #else
+ #ifdef MEMMOVE
+ ENTRY(memmove)
+ #else
+ ENTRY(bcopy)
+ #endif
+ #endif
+ 	movl	sp@(12),d1		| check count
+ 	beq	bcdone			| == 0, don't do anything
+ #if defined(MEMCOPY) || defined(MEMMOVE)
+ 	movl	sp@(4),a1		| dest address
+ 	movl	sp@(8),a0		| src address
+ #else
+ 	movl	sp@(4),a0		| src address
+ 	movl	sp@(8),a1		| dest address
+ #endif
+ 	cmpl	a1,a0			| src after dest?
+ 	blt	bcback			| yes, must copy backwards
+ 	movl	a0,d0
+ 	btst	#0,d0			| src address odd?
+ 	beq	bcfeven			| no, skip alignment
+ 	movb	a0@+,a1@+		| yes, copy a byte
+ 	subql	#1,d1			| adjust count
+ 	beq	bcdone			| count 0, all done 
+ bcfeven:
+ 	movl	a1,d0
+ 	btst	#0,d0			| dest address odd?
+ 	bne	bcfbloop		| yes, no hope for alignment, copy bytes
+ 	movl	d1,d0			| no, both even
+ 	lsrl	#2,d0			| convert count to longword count
+ 	beq	bcfbloop		| count 0, skip longword loop
+ bcflloop:
+ 	movl	a0@+,a1@+		| copy a longword
+ 	subql	#1,d0			| adjust count
+ 	bne	bcflloop		| still more, keep copying
+ 	andl	#3,d1			| what remains
+ 	beq	bcdone			| nothing, all done
+ bcfbloop:
+ 	movb	a0@+,a1@+		| copy a byte
+ 	subql	#1,d1			| adjust count
+ 	bne	bcfbloop		| still more, keep going
+ bcdone:
+ #if defined(MEMCOPY) || defined(MEMMOVE)
+ 	movl	sp@(4),d0		| dest address
+ #endif
+ 	rts
+ bcback:
+ 	addl	d1,a0			| src pointer to end
+ 	addl	d1,a1			| dest pointer to end
+ 	movl	a0,d0
+ 	btst	#0,d0			| src address odd?
+ 	beq	bcbeven			| no, skip alignment
+ 	movb	a0@-,a1@-		| yes, copy a byte
+ 	subql	#1,d1			| adjust count
+ 	beq	bcdone			| count 0, all done 
+ bcbeven:
+ 	movl	a1,d0
+ 	btst	#0,d0			| dest address odd?
+ 	bne	bcbbloop		| yes, no hope for alignment, copy bytes
+ 	movl	d1,d0			| no, both even
+ 	lsrl	#2,d0			| convert count to longword count
+ 	beq	bcbbloop		| count 0, skip longword loop
+ bcblloop:
+ 	movl	a0@-,a1@-		| copy a longword
+ 	subql	#1,d0			| adjust count
+ 	bne	bcblloop		| still more, keep copying
+ 	andl	#3,d1			| what remains
+ 	beq	bcdone			| nothing, all done
+ bcbbloop:
+ 	movb	a0@-,a1@-		| copy a byte
+ 	subql	#1,d1			| adjust count
+ 	bne	bcbbloop		| still more, keep going
+ #if defined(MEMCOPY) || defined(MEMMOVE)
+ 	movl	sp@(4),d0		| dest address
+ #endif
+ 	rts
*** /dev/null
--- NetBSD/src/sys/lib/libkern/arch/m68k/memcpy.S
***************
*** 0 ****
--- 1,2 ----
+ #define MEMCOPY
+ #include "bcopy.S"
*** old-NetBSD/src/sys/scsi/scsi_ioctl.c
--- NetBSD/src/sys/scsi/scsi_ioctl.c
***************
*** 166,172 ****
  		screq->retsts = SCCMD_UNKNOWN;
  		break;
  	}
! 	biodone(bp); 	/* we're waiting on it in scsi_strategy() */
  }
  
  
--- 166,172 ----
  		screq->retsts = SCCMD_UNKNOWN;
  		break;
  	}
! 	biodone(bp); 	/* we're waiting on it in scsistrategy() */
  }
  
  
*** old-NetBSD/src/sys/sys/mount.h
--- NetBSD/src/sys/sys/mount.h
***************
*** 380,388 ****
  struct adosfs_args {
  	char	*fspec;		/* blocks special holding the fs to mount */
  	struct	export_args export;	/* network export information */
! 	uid_t	uid;		/* uid that owns msdosfs files */
! 	gid_t	gid;		/* gid that owns msdosfs files */
! 	mode_t	mask;		/* mask to be applied for msdosfs perms */
  };
  
  #ifdef _KERNEL
--- 380,388 ----
  struct adosfs_args {
  	char	*fspec;		/* blocks special holding the fs to mount */
  	struct	export_args export;	/* network export information */
! 	uid_t	uid;		/* uid that owns adosfs files */
! 	gid_t	gid;		/* gid that owns adosfs files */
! 	mode_t	mask;		/* mask to be applied for adosfs perms */
  };
  
  #ifdef _KERNEL
*** old-NetBSD/src/sys/vm/swap_pager.c
--- NetBSD/src/sys/vm/swap_pager.c
***************
*** 71,77 ****
  #endif
  
  #ifdef DEBUG
! int	swpagerdebug = 0x100;
  #define	SDB_FOLLOW	0x001
  #define SDB_INIT	0x002
  #define SDB_ALLOC	0x004
--- 71,77 ----
  #endif
  
  #ifdef DEBUG
! int	swpagerdebug = 0x000;
  #define	SDB_FOLLOW	0x001
  #define SDB_INIT	0x002
  #define SDB_ALLOC	0x004
*** old-NetBSD/src/usr.bin/kdump/kdump.c
--- NetBSD/src/usr.bin/kdump/kdump.c
***************
*** 109,116 ****
--- 109,134 ----
  	{ NULL,			     NULL,		    NULL }
  };
  
+ struct emulation_map {
+ 	struct emulation_map *em_link;
+ 	pid_t		     em_pid;
+ 	struct emulation     *em_emulation;
+ };
+ 
+ /* Forward decls. */
+ struct emulation *emulation_from_name __P((char *name));
+ struct emulation *emulation_from_pid __P((pid_t pid));
+ void bind_emulation_to_pid __P((struct emulation *, pid_t));
+ 
+ /* A mapping between pids and emulations currently in charge.  */
+ struct emulation_map *current_emulations;
+ 
+ /* The current emulation (cache during a single trace event).  */
  struct emulation *current;
  
+ /* The default emulation, if nothing else is known.  */
+ struct emulation *default_emulation;
+ 
  
  static char *ptrace_ops[] = {
  	"PT_TRACE_ME",	"PT_READ_I",	"PT_READ_D",	"PT_READ_U",
***************
*** 127,138 ****
  	register void *m;
  	int trpoints = ALL_POINTS;
  
! 	current = &emulations[0];	/* NetBSD */
  
  	while ((ch = getopt(argc, argv, "e:f:dlm:nRTt:")) != -1)
  		switch (ch) {
  		case 'e':
! 			setemul(optarg);
  			break;
  		case 'f':
  			tracefile = optarg;
--- 145,156 ----
  	register void *m;
  	int trpoints = ALL_POINTS;
  
! 	default_emulation = &emulations[0];	/* NetBSD */
  
  	while ((ch = getopt(argc, argv, "e:f:dlm:nRTt:")) != -1)
  		switch (ch) {
  		case 'e':
! 			default_emulation = emulation_from_name(optarg);
  			break;
  		case 'f':
  			tracefile = optarg;
***************
*** 175,180 ****
--- 193,199 ----
  	if (!freopen(tracefile, "r", stdin))
  		err(1, "%s", tracefile);
  	while (fread_tail(&ktr_header, sizeof(struct ktr_header), 1)) {
+ 		current = emulation_from_pid(ktr_header.ktr_pid);
  		if (trpoints & (1<<ktr_header.ktr_type))
  			dumpheader(&ktr_header);
  		if ((ktrlen = ktr_header.ktr_len) < 0)
***************
*** 209,215 ****
  			ktrcsw((struct ktr_csw *)m);
  			break;
  		case KTR_EMUL:
! 			ktremul(m, ktrlen);
  			break;
  		}
  		if (tail)
--- 228,234 ----
  			ktrcsw((struct ktr_csw *)m);
  			break;
  		case KTR_EMUL:
! 			ktremul(m, ktrlen, ktr_header.ktr_pid);
  			break;
  		}
  		if (tail)
***************
*** 378,385 ****
  	(void)printf("\"%.*s\"\n", len, cp);
  }
  
! ktremul(cp, len) 
  	char *cp;
  {
  	char name[1024];
  
--- 397,405 ----
  	(void)printf("\"%.*s\"\n", len, cp);
  }
  
! ktremul(cp, len, pid) 
  	char *cp;
+ 	pid_t pid;
  {
  	char name[1024];
  
***************
*** 390,396 ****
  	name[len] = '\0';
  	(void)printf("\"%s\"\n", name);
  
! 	setemul(name);
  }
  
  ktrgenio(ktr, len)
--- 410,416 ----
  	name[len] = '\0';
  	(void)printf("\"%s\"\n", name);
  
! 	bind_emulation_to_pid(emulation_from_name(name), pid);
  }
  
  ktrgenio(ktr, len)
***************
*** 481,494 ****
  	exit(1);
  }
  
! setemul(name)
  	char *name;
  {
  	int i;
  	for (i = 0; emulations[i].name != NULL; i++)
  		if (strcmp(emulations[i].name, name) == 0) {
! 			current = &emulations[i];
! 			return;
  		}
  	warnx("Emulation `%s' unknown", name);
  }
--- 501,549 ----
  	exit(1);
  }
  
! struct emulation *
! emulation_from_name(name)
  	char *name;
  {
  	int i;
  	for (i = 0; emulations[i].name != NULL; i++)
  		if (strcmp(emulations[i].name, name) == 0) {
! 			return &emulations[i];
  		}
  	warnx("Emulation `%s' unknown", name);
+ 	return default_emulation;
+ }
+ 
+ struct emulation *
+ emulation_from_pid(pid)
+ 	pid_t pid;
+ {
+ 	struct emulation_map *entry;
+ 
+ 	for (entry = current_emulations; entry; entry = entry->em_link)
+ 		if (entry->em_pid == pid)
+ 			return entry->em_emulation;
+ 	return default_emulation;
+ }
+ 
+ void
+ bind_emulation_to_pid(emulation, pid)
+ 	struct emulation *emulation;
+ 	pid_t            pid;
+ {
+ 	struct emulation_map *entry;
+ 
+ 	for (entry = current_emulations; entry; entry = entry->em_link)
+ 		if (entry->em_pid == pid) {
+ 			entry->em_emulation = emulation;
+ 			return;
+ 		}
+ 	entry = current_emulations;
+ 	current_emulations =
+ 	    (struct emulation_map *)malloc(sizeof(struct emulation_map));
+ 	if (current_emulations == NULL)
+ 		errx(1, "%s", strerror(ENOMEM));
+ 	current_emulations->em_link = entry;
+ 	current_emulations->em_pid = pid;
+ 	current_emulations->em_emulation = emulation;
  }
